/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-ethercat-hardware-1.8.15-0quantal-20150808-0732/srv/SoftProcessorFirmwareRead.srv
 *
 */


#ifndef ETHERCAT_HARDWARE_MESSAGE_SOFTPROCESSORFIRMWAREREADRESPONSE_H
#define ETHERCAT_HARDWARE_MESSAGE_SOFTPROCESSORFIRMWAREREADRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace ethercat_hardware
{
template <class ContainerAllocator>
struct SoftProcessorFirmwareReadResponse_
{
  typedef SoftProcessorFirmwareReadResponse_<ContainerAllocator> Type;

  SoftProcessorFirmwareReadResponse_()
    : success(false)
    , error_msg()
    , instructions()  {
    }
  SoftProcessorFirmwareReadResponse_(const ContainerAllocator& _alloc)
    : success(false)
    , error_msg(_alloc)
    , instructions(_alloc)  {
    }



   typedef uint8_t _success_type;
  _success_type success;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _error_msg_type;
  _error_msg_type error_msg;

   typedef std::vector<uint32_t, typename ContainerAllocator::template rebind<uint32_t>::other >  _instructions_type;
  _instructions_type instructions;




  typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SoftProcessorFirmwareReadResponse_

typedef ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<std::allocator<void> > SoftProcessorFirmwareReadResponse;

typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorFirmwareReadResponse > SoftProcessorFirmwareReadResponsePtr;
typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorFirmwareReadResponse const> SoftProcessorFirmwareReadResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ethercat_hardware

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'ethercat_hardware': ['/tmp/buildd/ros-hydro-ethercat-hardware-1.8.15-0quantal-20150808-0732/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d36ea5e74d6ac75d45ab5ae553b4d4e6";
  }

  static const char* value(const ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd36ea5e74d6ac75dULL;
  static const uint64_t static_value2 = 0x45ab5ae553b4d4e6ULL;
};

template<class ContainerAllocator>
struct DataType< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ethercat_hardware/SoftProcessorFirmwareReadResponse";
  }

  static const char* value(const ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool success\n\
string error_msg\n\
uint32[] instructions\n\
\n\
";
  }

  static const char* value(const ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.success);
      stream.next(m.error_msg);
      stream.next(m.instructions);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SoftProcessorFirmwareReadResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ethercat_hardware::SoftProcessorFirmwareReadResponse_<ContainerAllocator>& v)
  {
    s << indent << "success: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.success);
    s << indent << "error_msg: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.error_msg);
    s << indent << "instructions[]" << std::endl;
    for (size_t i = 0; i < v.instructions.size(); ++i)
    {
      s << indent << "  instructions[" << i << "]: ";
      Printer<uint32_t>::stream(s, indent + "  ", v.instructions[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ETHERCAT_HARDWARE_MESSAGE_SOFTPROCESSORFIRMWAREREADRESPONSE_H
