/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-ethercat-hardware-1.8.15-0quantal-20150808-0732/srv/SoftProcessorReset.srv
 *
 */


#ifndef ETHERCAT_HARDWARE_MESSAGE_SOFTPROCESSORRESETREQUEST_H
#define ETHERCAT_HARDWARE_MESSAGE_SOFTPROCESSORRESETREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace ethercat_hardware
{
template <class ContainerAllocator>
struct SoftProcessorResetRequest_
{
  typedef SoftProcessorResetRequest_<ContainerAllocator> Type;

  SoftProcessorResetRequest_()
    : actuator_name()
    , processor_name()  {
    }
  SoftProcessorResetRequest_(const ContainerAllocator& _alloc)
    : actuator_name(_alloc)
    , processor_name(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _actuator_name_type;
  _actuator_name_type actuator_name;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _processor_name_type;
  _processor_name_type processor_name;




  typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SoftProcessorResetRequest_

typedef ::ethercat_hardware::SoftProcessorResetRequest_<std::allocator<void> > SoftProcessorResetRequest;

typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorResetRequest > SoftProcessorResetRequestPtr;
typedef boost::shared_ptr< ::ethercat_hardware::SoftProcessorResetRequest const> SoftProcessorResetRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ethercat_hardware

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'ethercat_hardware': ['/tmp/buildd/ros-hydro-ethercat-hardware-1.8.15-0quantal-20150808-0732/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "777be25d71e9e85e62fa14223ffddb6b";
  }

  static const char* value(const ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x777be25d71e9e85eULL;
  static const uint64_t static_value2 = 0x62fa14223ffddb6bULL;
};

template<class ContainerAllocator>
struct DataType< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ethercat_hardware/SoftProcessorResetRequest";
  }

  static const char* value(const ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string actuator_name\n\
string processor_name\n\
\n\
";
  }

  static const char* value(const ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.actuator_name);
      stream.next(m.processor_name);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SoftProcessorResetRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ethercat_hardware::SoftProcessorResetRequest_<ContainerAllocator>& v)
  {
    s << indent << "actuator_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.actuator_name);
    s << indent << "processor_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.processor_name);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ETHERCAT_HARDWARE_MESSAGE_SOFTPROCESSORRESETREQUEST_H
